// Module: IntervalRebinner.h
// Author: Hassan Siddiqui
//
// Description: 
// Rebins the ranges defined by an input BinnedAxis object
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: IntervalRebinner.h,v 1.1 2000/03/28 12:42:50 hsiddiqu Exp $

#ifndef IntervalRebinner_H
#define IntervalRebinner_H


/* General classes */

/* SAS-specific classes */
#include "CalCommon.h"

/* Local classes */
#include "NonUnifBinnedAxis.h"

/***********************************************************
 *
 * class IntervalRebinner
 *
 ***********************************************************/

class IntervalRebinner
{

 public:

  /* Constructor */
  IntervalRebinner(); 

  /* Destructor */
  ~IntervalRebinner();

  /* Return a object containing the resampled intervals, 
   * based on an input BinnedAxis object. */
  static IntervalVector<double> rebin(const BinnedAxis * in,
				      unsigned binfactor,
				      unsigned offset);
  
private:
};

#endif




