// 
// Module: MOSMonoPixelFuncs
// Author: Hassan Siddiqui
//
// Modifications: See ChangeLog
// 
// $Id: MOSMonoPixelPatternFuncs.h,v 1.1 2000/03/28 12:42:51 hsiddiqu Exp $

#ifndef MOSMonoPixelFuncs_H
#define MOSMonoPixelFuncs_H

/* General classes */
#include <cmath>

/* SAS-specific */
#include "Dal.h"
#include "Tracer.h"

/* Local classes */
#include "SplitPatternFuncs.h"
#include "SplitEventsData.h"


// =================================================================

// class MOSMonoPixelPatternFuncs

// Contains algorithms to correct for pile-up where the pattern of interest
// is of mono-pixel type.

// =================================================================

class MOSMonoPixelPatternFuncs : public SplitPatternFuncs
{
public:
  
  /* Constructors */
  MOSMonoPixelPatternFuncs(const SplitEventsData & splitEventsData);

  ~MOSMonoPixelPatternFuncs();

protected:

  /* Note flux is in units of /frame/pixel */

  const PileupData getPileup( const SplitEventsDist& alpha,
			       double flux )  const;

};

#endif
