// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: NullResponseCorrector
// Author: Hassan Siddiqui
//
// Description: 
// Corrects response for pile-up
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: NullResponseCorrector.h,v 1.1 2000/03/28 12:42:53 hsiddiqu Exp $

#ifndef NullResponseCorrector_H
#define NullResponseCorrector_H

// General classes

#include <iostream>
#include <vector>
#include <map>

// SAS-specific classes

#include "Dal.h"
#include "Tracer.h"

// Local Classes
#include "GenericResponse.h"
#include "ResponseCorrector.h"

// -----------------------------------------------------------------------------------

// class NullResponseCorrector

// Applies NO correction to response.

// -----------------------------------------------------------------------------------

class NullResponseCorrector : public ResponseCorrector
{

public:
  
  /* Constructor */

  NullResponseCorrector(  const GenericResponse *  response ): 
    _response(response)
    {
    }


  /* Factory methods */

  const vector<double> correctedResponse( const Interval<double>& ebin0 ) const
    {
      PROC;

      vector<double> response0 = _response->responseVector(ebin0);

      RETURN response0;
    }
     
private:

  /* Data members */

  const GenericResponse * _response;

  /* Functions */

  // Suppress default constructor
  NullResponseCorrector();

  
};

#endif






