// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: NullSplitEventsData
// Author: Hassan Siddiqui
//
// Modifications: See ChangeLog
// 
// $Id: NullSplitEventsData.h,v 1.2 1999/05/28 08:01:09 hsiddiqu Exp $

#ifndef NullSplitEventsData_H
#define NullSplitEventsData_H

// General classes
#include <iostream>

// SAS-specific classes

// General utility functions
#include "Tracer.h"
#include <vector>
#include "NumericalRange.h"

// Local classes
#include "SplitEventsData.h"

// ===========================================================================

// class NullSplitEventsData

// A SplitEventsData class which returns a simple vector for all energies.
// Useful for debugging.

// ===========================================================================

typedef vector<double> SplitEventsDist;

class NullSplitEventsData :  public SplitEventsData
{

public:

  //  Constructors 
  NullSplitEventsData(unsigned int numberOfPatterns):
    SplitEventsData(numberOfPatterns)
    {
      assert(numberOfPatterns > FLT64_MIN);

      int npatterns = (int) numberOfPatterns;

      for (int i = 0; i < npatterns; ++i)
	{
	      _myDist.push_back(1./npatterns);
	}

    };

  NullSplitEventsData(const SplitEventsDist & dist):
    SplitEventsData(dist.size())
    {
      for (SplitEventsDist::const_iterator itr = dist.begin();
	   itr != dist.end();
	   ++itr)
	{
	      _myDist.push_back(*itr);
	}

    };

  /*  Destructors */
  ~NullSplitEventsData(){};

  const SplitEventsDist dist( double /* energy */ ) const
    {
      PROC;
      RETURN _myDist;

    };

private:

  SplitEventsDist _myDist;
};

#endif
