// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: PatternData
// Author: Hassan Siddiqui
//
// Modifications: See ChangeLog
// 
// $Id: PatternData.cc,v 1.1 2000/03/28 12:42:54 hsiddiqu Exp $

/* General */
#include <cmath>
#include<cassert>

/* SAS-specific */
#include "Dal.h"
#include "Tracer.h"

/* Local */
#include "PatternData.h"
#include "NumericalRange.h"
#include "PatternFuncs.h"

// =================================================================

// class PatternData

// =================================================================

/* Constructors */
PatternData::PatternData(){};

/* Destructors */
PatternData::~PatternData()
    {
//       for (vector< PatternFuncs *>::iterator itr = _patternFuncsVector.begin();
// 	   itr != _patternFuncsVector.end();
// 	   ++itr)
// 	{
// 	  /* If pointer points to a PatternFuncs object, delete the object */
// 	  if (*itr)
// 	    {
// 	      delete (*itr); (*itr) = 0;
// 	    }
// 	}
    }

unsigned int PatternData::numberOfPatterns() const
{
  PROC;
  RETURN _patternFuncsVector.size();
}


  /* Compute detected rate */ 
  double  PatternData::piledupCtRate( double       energy, 
			 double       rate ) const
    {
      PROC;

      double sum = 0;

      for ( vector<PatternFuncs * >::const_iterator itr = 
	      _patternFuncsVector.begin();
	    itr != _patternFuncsVector.end();
	    ++itr)
	{
	  sum +=
	    (*itr)->piledupCtRate(energy, rate);
	}

      RETURN sum;
    }

  double  PatternData::piledupCtRate( double       energy, 
			 double       rate,
			 unsigned int pattern_index) const
    {
      PROC;
      assert(pattern_index < numberOfPatterns());
      RETURN _patternFuncsVector[pattern_index]->piledupCtRate(energy, rate);
    }


  /* Compute ideal detected rate assuming no pile-up */ 
  double  PatternData::trueCtRate( double       energy, 
		      double       rate ) const
    {
      PROC;

      double sum = 0;

      for ( vector<PatternFuncs * >::const_iterator itr = 
	      _patternFuncsVector.begin();
	    itr != _patternFuncsVector.end();
	    ++itr)
	{
	  sum +=
	    (*itr)->trueCtRate(energy, rate);
	}

      RETURN sum;
    }

  double  PatternData::trueCtRate( double       energy, 
		      double       rate,
		      unsigned int pattern_index) const
    {
      PROC;
      assert(pattern_index < numberOfPatterns());
      RETURN _patternFuncsVector[pattern_index]->trueCtRate(energy, rate);
    }

  /* Compute detected rate as a fraction of incident rate*/ 
  double  PatternData::fluxAttenuation( double       energy, 
			   double       incidentrate ) const
    {
      PROC;
      assert(incidentrate > FLT64_MIN);
      RETURN piledupCtRate(energy, incidentrate)/incidentrate;
    }

  /* Compute detected rate as a fraction of incident rate*/ 
  double  PatternData::pileupFraction( double       energy, 
			  double       incidentrate ) const
    {
      PROC;
      double piledupctrate = piledupCtRate(energy, incidentrate);
      assert(piledupctrate > FLT64_MIN);

      RETURN 1-(trueCtRate(energy, incidentrate)/piledupctrate);
    }



  void    PatternData::add ( PatternFuncs * patternFuncs)
    {
      PROC;
      _patternFuncsVector.push_back(patternFuncs);
      ENDPROC;
    }
