// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: PatternData
// Author: Hassan Siddiqui
//
// Modifications: See ChangeLog
// 
// $Id: PatternData.h,v 1.4 2000/03/28 12:42:54 hsiddiqu Exp $

#ifndef PatternData_H
#define PatternData_H

/* General */
#include <cmath>

/* SAS-specific */

/* Local */
#include "PatternFuncs.h"

// =================================================================

// class PatternData

// =================================================================

class PatternData
{
public:

  /* Destructors */
  virtual ~PatternData();

  unsigned int numberOfPatterns() const;


  /* Compute detected rate */ 
  double  piledupCtRate( double       energy, 
			 double       rate ) const;

  double  piledupCtRate( double       energy, 
			 double       rate,
			 unsigned int pattern_index) const;


  /* Compute ideal detected rate assuming no pile-up */ 
  double  trueCtRate( double       energy, 
		      double       rate ) const;

  double  trueCtRate( double       energy, 
		      double       rate,
		      unsigned int pattern_index) const;

  /* Compute detected rate as a fraction of incident rate*/ 
  double  fluxAttenuation( double       energy, 
			   double       incidentrate ) const;

  /* Compute detected rate as a fraction of incident rate*/ 
  double  pileupFraction( double       energy, 
			  double       incidentrate ) const;

  void    add ( PatternFuncs * patternFuncs);

protected:

  /* Don't want an instance made of this class 
   * Construct only in derived classes */ 
  PatternData();

private:

  vector<PatternFuncs * > _patternFuncsVector;
  

};
#endif
