// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: responsegrouping.h
// Author: Hassan Siddiqui
//
// Description: Classes which allow the response matrix to be groups.
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: ResponseGrouping.h,v 1.1 2000/03/28 12:42:58 hsiddiqu Exp $

#ifndef ResponseGrouping_H
#define ResponseGrouping_H


// General classes
#include <iostream>
#include <list>

// SAS-specific classes
#include "Dal.h"
#include "NumericalRange.h"

// General utility classes
#include "Tracer.h"


// ============================================================================

// class ResponseElement

// Stores the channel number and response value for a given response element

// ============================================================================

class ResponseElement
{
public:
  
  // Suppress default constructor
  ResponseElement();
  
  ResponseElement(unsigned long channel, double value) : 
    _channel(channel), _value(value) {}
  
  unsigned long channel() const { PROC RETURN _channel;}

  double value() const { PROC RETURN _value;}
    
private:

  unsigned long _channel;
  double _value;

};
  



// =======================================================================

// class ResponseGroup

// =======================================================================

class ResponseGroup : public list<ResponseElement>

{
public:

  ResponseGroup(unsigned long startofgroup) : _start_of_group(startofgroup) {}

  // Suppress default constructor
  ResponseGroup();

  unsigned long startofgroup() const {PROC RETURN _start_of_group; }

private:

  unsigned long _start_of_group;

};

#endif




