// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: testTablePhotonDistribution
// Author: Hassan Siddiqui
//
// Description: Test code to check int8 structure i/o
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: testTablePhotonDistribution.cc,v 1.3 1999/05/28 08:01:13 hsiddiqu Exp $


// General classes

#include <iostream>
#include <cmath>

// SAS-specific classes

#include "Dal.h"
#include "FileLocator.h"
//#include "DalExt.h"
#include "errstr.h"

// General utility functions
#include "Tracer.h"

// Local classes
#include "TablePhotonDistribution.h"

// ---------------------------------------------------

// Main function

// ---------------------------------------------------


int main()
{
  PROC;

  static const double _TOLERANCE    = 1e-4; // Set tolerance level to 0.1 % in comparison tests

  static const double _EXPECTEDFLUX = 3e-5;

  // Create a photon distribution object

  TablePhotonDistribution dist("flatPhotonDistribution.fits");

  // Check flux between 2.5 and 30 keV
  for (unsigned int i  = 25; i < 300; ++i)
    {
      double flux = dist.flux(i / 10.);
      
      cout << flux << " " << _EXPECTEDFLUX << endl;
      cout << fabs(flux - _EXPECTEDFLUX)/_EXPECTEDFLUX << " " << _TOLERANCE << endl;

      if ( fabs(flux - _EXPECTEDFLUX)/_EXPECTEDFLUX > _TOLERANCE )
	{
	  Sas::error("wrongFlux","the resultand flux differs from the expected value"); 
	}
    }

  RETURN 0;
} 

